Class: Aws::ConnectScheduling::Types::CreateTimeOffRequest

Inherits:
Struct
  • Object
show all
Defined in:
gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb

Overview

The request for CreateTimeOff.

Constant Summary collapse

SENSITIVE =
[:description]

Instance Attribute Summary collapse

Instance Attribute Details

#approval_type ⇒ String

Controls who approves the request. AWAIT_APPROVAL waits for an ApproveTimeOff or RejectTimeOff call. AUTOMATIC has Connect Customer decide the request. For details, see CreateTimeOff.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#client_token ⇒ String

A unique, case-sensitive identifier that you provide to ensure that the operation completes no more than one time. If this token matches a previous request, Connect Customer returns the result of that request and doesn't create another time off request. If you don't provide a token, the AWS SDK populates this field. If you reuse a client token with a different request body, the request fails with ValidationException. For more information about idempotency, see Making retries safe with idempotent APIs.

A suitable default value is auto-generated. You should normally not need to pass this option.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#description ⇒ String

A description recorded on the time off request. If you omit it, the request has no description.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#end_at ⇒ Time

The end of the time off window, exclusive. It must be after StartAt and no later than 24 months after the current date. Connect Customer stores the value as sent, to the millisecond.

Returns:

  • (Time)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#instance_id ⇒ String

The identifier of the Connect Customer instance. This can be the ID or the ARN of the instance. You can find the instance ID in the Amazon Resource Name (ARN) of the instance.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#rule_failure_action ⇒ String

Controls what happens when a configured rule fails. REJECT, the default, records an ERROR and ends the request REJECTED, unless the whole window is in the past. OVERRIDE records a WARNING and ends the request APPROVED, like the Override time off rules option in the Connect Customer admin website. OVERRIDE requires AUTOMATIC. With AWAIT_APPROVAL, OVERRIDE fails with ValidationException. Set it on ApproveTimeOff instead. OVERRIDE never waives CONFLICTING_TIME_OFF_REQUEST.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#shift_activity_id ⇒ String

The identifier of the shift activity that defines the type of time off being requested. This can be the ID or the ARN of the shift activity. It must be a time off activity. Activities that aren't set as Requestable are accepted.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#start_at ⇒ Time

The start of the time off window, inclusive. It must be no earlier than one year before the current date. Connect Customer stores the value as sent, to the millisecond.

Returns:

  • (Time)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end

#user_id ⇒ String

The identifier of the user who the time off request is for. This can be the ID or the ARN of the user.

Returns:

  • (String)


258
259
260
261
262
263
264
265
266
267
268
269
270
# File 'gems/aws-sdk-connectscheduling/lib/aws-sdk-connectscheduling/types.rb', line 258

class CreateTimeOffRequest < Struct.new(
  :instance_id,
  :user_id,
  :shift_activity_id,
  :start_at,
  :end_at,
  :description,
  :approval_type,
  :rule_failure_action,
  :client_token)
  SENSITIVE = [:description]
  include Aws::Structure
end